Composer dependencies in Drupal contrib

Submitted by Anonymous (not verified) on Fri, 22/01/2016 - 11:51

<p>Drupal 8 is out, Drupal 8.1 will be out before we know it, but it seems contrib is still catching up. One question that seems to keep coming up is around installing a Drupal 8 module. In this post I will look at the different ways to install a module and resolving dependencies.</p>

<p><a href="https://www.drupal.org/project/deploy&quot; target="_blank">Deploy</a>, <a href="https://www.drupal.org/project/search_api_solr&quot; target="_blank">Search API Solr Search</a>, and <a href="https://www.drupal.org/project/commerce&quot; target="_blank">Commerce</a> are just a few of the modules with Drupal 8 releases that require dependencies loaded via composer. This means you can’t just download the module’s ZIP file, unzip it in your modules directory, and enable it. You need to install the dependencies.</p>

<p>One simple way to do this is the <a href="https://www.drupal.org/project/composer_manager&quot; target="_blank">Composer Manager</a> module. This module has <a href="https://www.drupal.org/node/2405811&quot; target="_blank">extensive documentation</a> on how to use it. Essentially what it does it merge the composer.json that ships with core and the composer.json files from all the contrib module you have, then downloads the dependencies. You may notice that this will also update core dependencies, but this is a good thing! The core composer.json has been written in such a way that it won’t introduce API breaking dependencies and only uses stable releases. So you will benefit from any bug fixes or security fixes rolled out in these dependencies before they’re rolled out with Drupal.</p>

<p>The two other ways we’re going to look at involve directly using Composer.</p>

<p><strong>Just the dependencies</strong><br/>
It’s possible to carry on installing Drupal modules exactly as you always have, download the zip or tarball, then unzip it into your modules directory. As mentioned earlier this will not install the dependencies, therefore you will need to look inside the module’s composer.json file, see what the dependencies are, and install them manually. Let’s take Deploy module as an example, this depends on the dev-master version of <a href="https://packagist.org/packages/relaxedws/replicator&quot; target="_blank">relaxedws/replicator</a>. So, go to your Drupal docroot and run the command <code>composer require relaxedws/replicator:dev-master</code>. This will add relaxedws/replicator to Drupal’s composer.json, download it, and put it in the vendor directory ready for the module to make use of. This will not change any other other dependencies you have. Then to update the dependencies you can either run <code>composer update</code> to update relaxedws/replicator and all core dependencies or <code>composer update relaxedws/replicator</code> to just update the relaxedws/replicator package.</p>

<p><strong>The module too</strong><br/>
If you install all you Drupal modules via composer, all of the dependencies will automatically be installed too. First you will need to add a new repository, so run <code>composer config repositories.drupal composer <a href="https://packagist.drupal-composer.org&quot; target="_blank">https://packagist.drupal-composer.org</a></code&gt; in your Drupal docroot, this will add the <a href="https://packagist.drupal-composer.org&quot; target="_blank">https://packagist.drupal-composer.org</a&gt; repository to your drupal composer.json. Now you can install any module from Drupal.org via composer. So going back to the example of Deploy you can run <code>composer require drupal/deploy:8.1.0-alpha5</code> in your Drupal docroot and it will install Deploy in the modules directory. It will also install key_value, multiversion, and relaxed, which are all Drupal modules required by Deploy. Furthermore it will install relaxedws/replicator as we know is a PHP package needed for Deploy, and doctrine/couchdb which is a PHP package needed for releaxedws/replicator.</p>

<p>I hope this helps those confused what to do with Drupal 8 modules that have composer dependencies. Now go do the smart thing, rebuild your site using Composer!</p>

Add new comment